class AmberForceFieldDict:

    _commonpara={
        'H':10,'H1':232,'H2':232,'H3':232,'HA':12,'HD1':24,'HD2':24,'HD3':24,
        'CA':8,'CG1':17,'CG2':17,'C':9,'CTe':233,
        'N':7,'NTe':231,
        'O':11,'OXT':234,'OC1':234,'OC2':234,'OTe':234,
    }

    #In AMOEBABIO18, S in both of S-S and S-H is defined as SG. Hence, here we define SGS is S in S-S
    _amberpara={
        'GLY': {**_commonpara, **{"N":1,"CA":2,"C":3,"HN":4,"O":5,"HA":6,"HA1":6,"HA2":6,"HA3":6,'H':4}},
        'ALA': {**_commonpara, **{"N":7,"CA":8,"C":9,"HN":10,"O":11,"HA":12,"CB":13,"HB":14,"HB1":14,"HB2":14,"HB3":14,}},
        'VAL': {**_commonpara, **{"CB":15,"HB":16,'HB1':16,'HB2':16,'HB3':16,"CG":17,"HG":18,'HG11':18,'HG12':18,'HG13':18,'HG21':18,'HG22':18,'HG23':18,},},
        'LEU': {**_commonpara, **{"CB":19,"HB":20,'HB1':20,'HB2':20,'HB3':20,"CG":21,"HG":22,"CD":23,"CD1":23,"CD2":23,"HD":24,"HD11":24,"HD12":24,"HD13":24,"HD21":24,"HD22":24,"HD23":24,}},
        'ILE': {**_commonpara, **{"CB":25,"HB":26,"HB2":26,"HB3":26,"CG1":27,"HG1":28,"HG11":28,"HG12":28,"HG12":28,"HG13":28,"HG21":30,"HG22":30,"HG23":30,"CG2":29,"HG2":30,"CD":31,'CD1':31,"HD":32,"HD1":32,"HD2":32,"HD3":32,"HD11":32,"HD12":32,"HD13":32,}},
        'SER': {**_commonpara, **{"CB":33,"HB":34,"HB1":34,"HB2":34,"HB3":34,"OG":35,"HG":36,'HB2':34,'HB3':34}},
        'THR': {**_commonpara, **{"CB":37,"HB":38,"HB2":38,"HB3":38,"OG1":39,"HG1":40,'HG21':42,'HG22':42,'HG23':42,"CG2":41,"HG2":42,}},
        'CYS': {**_commonpara, **{"CB":43,"HB":44,"HB1":44,"HB2":44,"HB3":44,"HG":46,"SG":45,'SGS':47}},
        'CYSA': {**_commonpara, **{"CA":48,"S-":49,}},
        'PRO': {**_commonpara, **{"N":50,"CA":51,"C":52,"O":53,"HA":54,"CB":55,"HB":56,"HB1":56,"HB2":56,"HB3":56,"CG":57,"HG":58,"HG1":58,"HG2":58,"HG3":58,"CD":59,"HD":60,"HD1":60,"HD2":60,"HD3":60,}},
        'PHE': {**_commonpara, **{"CB":61,"HB":62,"HB1":62,"HB2":62,"HB3":62,"CG":63,"CD":64,"CD1":64,"CD2":64,"HD":65,"HD1":65,"HD2":65,"HD3":65,"CE":66,"CE1":66,"CE2":66,"HE":67,"HE1":67,"HE2":67,"CZ":68,"HZ":69,}},
        'TYR': {**_commonpara, **{"CB":70,"HB":71,"HB1":71,"HB2":71,"HB3":71,"CG":72,"CD":73,"CD1":73,"CD2":73,"HD":74,"HD1":74,"HD2":74,"HD3":74,"CE":75,"CE1":75,"CE2":75,"HE":76,"HE1":76,"HE2":76,"CZ":77,"OH":78,"HH":79,}},
        'TYRA': {**_commonpara, **{"CB":80,"HB":81,"HB2":81,"HB3":81,"CG":82,"CD":83,"HD":84,"CE":85,"HE":86,"CZ":87,"O-":88,}},
        'TRP': {**_commonpara, **{"CB":89,"HB":90,"HB1":90,"HB2":90,"HB3":90,"CG":91,"CD1":92,"HD1":93,"CD2":94,"NE1":95,"HE1":96,"CE2":97,"CE3":98,"HE3":99,"CZ2":100,"HZ2":101,"CZ3":102,"HZ3":103,"CH2":104,"HH2":105,}},
        'HIS': {**_commonpara, **{"CB":106,"HB":107,"HB1":107,"HB2":107,"HB3":107,"CG":108,"ND1":109,"HD1":110,"CD2":111,"HD2":112,"CE1":113,"HE1":114,"NE2":115,"HE2":116,}},
        'HIS?': {**_commonpara, **{"CB":117,"HB":118,"HB1":118,"HB2":118,"HB3":118,"CG":119,"ND1":120,"HD1":121,"CD2":122,"HD2":123,"CE1":124,"HE1":125,"HE2":125,"NE2":126,}},
        'HIE': {**_commonpara, **{"CB":127,"HB":128,"HB1":128,"HB2":128,"HB3":128,"CG":129,"ND1":130,"CD2":131,"HD2":132,"CE1":133,"HE1":134,"NE2":135,"HE2":136,}},
        'ASP(full)': {**_commonpara, **{"CB":137,"HB":138,"HB1":138,"HB2":138,"HB3":138,"CG":139,"OD":140,}},
        'ASP': {**_commonpara, **{"CB":137,"HB":138,"HB1":138,"HB2":138,"HB3":138,"CG":139,"OD1":140,"OD2":140,"HD2":146,}},
        'ASN': {**_commonpara, **{"CB":147,"HB":148,"HB1":148,"HB2":148,"HB3":148,"CG":149,"OD1":150,"ND2":151,"HD2":152,"HD21":152,"HD22":152,}},
        'GLU(full)': {**_commonpara, **{"CB":153,"HB":154,"HB1":154,"HB2":154,"HB3":154,"CG":155,"HG":156,"CD":157,"OE":158,}},
        'GLU': {**_commonpara, **{"CB":153,"HB":154,"HB1":154,"HB2":154,"HB3":154,"CG":155,"HG":156,"HG1":156,"HG2":156,"HG3":156,"CD":157,"OE1":158,"OE2":158,"HE2":166,}},
        'GLN': {**_commonpara,**{"CB":167,"HB":168,"HB1":168,"HB2":168,"HB3":168,"CG":169,"HG":170,"HG1":170,"HG2":170,"HG3":170,"CD":171,"OE1":172,"NE2":173,"HE2":174,"HE21":174,"HE22":174,},},
        'MET': {**_commonpara,**{"CB":175,"HB":176,"HB1":176,"HB2":176,"HB3":176,"CG":177,"HG":178,"HG1":178,"HG2":178,"HG3":178,"SD":179,"CE":180,"HE":181,"HE1":181,"HE2":181,"HE3":181,},},
        'LYS': {**_commonpara,**{"CB":182,"HB":183,"HB1":183,'HB2':183,'HB3':183,"CG":184,"HG":185,"HG1":185,'HG2':185,'HG3':185,"CD":186,"HD":187,"HD1":187,"HD2":187,"HD3":187,"CE":188,"HE":189,"HE1":189,"HE2":189,"HE3":189,"NZ":190,"HZ1":191,"HZ2":191,"HZ3":191,"HN":191,},},
        'ARG': {**_commonpara,**{"CB":202,"HB":203,"HB1":203,"HB2":203,"HB3":203,"CG":204,"HG":205,"HG1":205,"HG2":205,"HG3":205,"CD":206,"HD":207,"HD1":207,"HD2":207,"HD3":207,"NE":208,"HE":209,"CZ":210,"NH":211,"NH1":211,"NH2":211,"HH":212,"HH11":212,"HH12":212,"HH21":212,"HH22":212,},},
        }

    